library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

-- Somehow count the number of switches
-- With a special coding to have also 4 switches counted
-- 0 and 1 switches result in 0
-- 2 switches = "01"
-- 3 switches = "10"
-- 4 switches = "11"

entity addcomb is 
  port (
    switch_i:   in std_ulogic_vector(3 downto 0);
    sum_o:      out unsigned(2 downto 0)
  );
end; 

architecture rtl of addcomb is
  
  signal s0 : unsigned(2 downto 0);
  
begin

  process (switch_i(3 downto 0))
  begin
    case switch_i(3 downto 0) is
 	    when "0000"                      => s0 <= "000";
		  when "1000"|"0100"|"0010"|"0001" => s0 <= "001";
		  when "1100"|"1010"|"1001"|
		       "0110"|"0101"|"0011"        => s0 <= "010";
	    when "1110"|"1101"|"1011"|"0111" => s0 <= "011";
		  when "1111"                      => s0 <= "100";
		  when others                      => s0 <= "000";
    end case;
  end process;  

  sum_o <= s0;    
 			   
end; -- architecture


